System.register(["cc"], function (_export, _context) {
  "use strict";

  var _cclegacy, dynamicAtlasManager, macro, _decorator, Component, Node, Label, instantiate, v3, _dec, _dec2, _dec3, _class, _class2, _descriptor, _descriptor2, _crd, ccclass, property, DrawScript;

  function _initializerDefineProperty(target, property, descriptor, context) { if (!descriptor) return; Object.defineProperty(target, property, { enumerable: descriptor.enumerable, configurable: descriptor.configurable, writable: descriptor.writable, value: descriptor.initializer ? descriptor.initializer.call(context) : void 0 }); }

  function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }

  function _initializerWarningHelper(descriptor, context) { throw new Error('Decorating class property failed. Please ensure that ' + 'proposal-class-properties is enabled and runs after the decorators transform.'); }

  return {
    setters: [function (_cc) {
      _cclegacy = _cc.cclegacy;
      dynamicAtlasManager = _cc.dynamicAtlasManager;
      macro = _cc.macro;
      _decorator = _cc._decorator;
      Component = _cc.Component;
      Node = _cc.Node;
      Label = _cc.Label;
      instantiate = _cc.instantiate;
      v3 = _cc.v3;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "e8b0evFJq5OpaeywzNQsP7J", "DrawScript", undefined);

      ({
        ccclass,
        property
      } = _decorator);

      _export("DrawScript", DrawScript = (_dec = ccclass('DrawScript'), _dec2 = property(Node), _dec3 = property(Label), _dec(_class = (_class2 = class DrawScript extends Component {
        constructor() {
          super(...arguments);

          _initializerDefineProperty(this, "spNode", _descriptor, this);

          _initializerDefineProperty(this, "label", _descriptor2, this);

          this._count = 0;
        }

        start() {
          //开启动态合图--耗内存--关闭动态合图
          dynamicAtlasManager.enabled = false;
          macro.ENABLE_TRANSPARENT_CANVAS = false;
          this.schedule(this.createSp, 2);
          this.schedule(this.sortZindex, 1);
        }

        createSp() {
          var count = 100;
          this._count += count;
          this.label.string = this._count + '';

          for (var i = 0; i < count; i++) {
            var spNode = instantiate(this.spNode);
            spNode.parent = this.node;
            spNode.setPosition(v3(Math.random() * 900 - 450, Math.random() * 500 - 250));
          }

          if (this._count > 200) {
            this.unschedule(this.createSp);
          }
        }

        sortZindex() {
          this.node.children.sort(function (a, b) {
            return b.position.y - a.position.y;
          });
        }

      }, (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "spNode", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function initializer() {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "label", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function initializer() {
          return null;
        }
      })), _class2)) || _class));

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=1ba78dc270f0d0efc1086527f9110310c8000739.js.map